//TGA -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#define UNCOMP_8BITS   1
#define COMP_8BITS     9
#define UNCOMP_RGB     2
#define COMP_RGB      10
#define TEXT_SIZE    256


#pragma pack(1)
typedef struct {
    BYTE no_characters;         // Length of Image Identification Field
    BYTE map_type;              //  0 = no color map     1 = color map
    BYTE type;                  //  1 = Color-mapped image Uncommpressed
                                //  2 = RGB image Uncompressed
                                //  9 = Color-mapped image RLE Compressed
                                // 10 = RGB image Compressed

    WORD map_origin;            // Color Map Origin
    WORD map_length;            // Color Map Length
    BYTE map_size;              // Number of bits in each color map entry

    WORD x_origin;
    WORD y_origin;
    WORD width;
    WORD height;
    BYTE bits;
    BYTE descriptor;
}HEAD_TGA;
#pragma pack()


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

BYTE *map;

BYTE *far1;
BYTE *far3;
BYTE *mainligt;
BYTE *near1;
BYTE *near2;
BYTE *near3;
BYTE *near4;
BYTE *near5;
BYTE *near6;

BYTE        cell=4;             //Modificar esto para darle ms detalle.
                                //1=detalle mximo.
float       ShadowFactor=0.0;

float       step=3;           //Avance de los objetos por pulsacin.

float       SDist=255;             //Distancia a la pantalla.

DWORD         Xstart, X1, Y1;

DWORD       texu, texv;
static float       t, t1 ;

BOOLEAN     last_hit_sphere;

#pragma pack(1)
typedef struct {
    float       x;
    float       y;
    float       z;
} ray;
#pragma pack()

#pragma pack(1)
typedef struct {
    DWORD       x;
    DWORD       y;
} vertex2D;
#pragma pack()

#pragma pack(1)
typedef struct {
    SDWORD       x;
    SDWORD       y;
} Svertex2D;
#pragma pack()


#pragma pack(1)
typedef struct {
    SDWORD       xmin;
    SDWORD       ymin;
    SDWORD       xmax;
    SDWORD       ymax;
} slab;
#pragma pack()

#pragma pack(1)
typedef struct sphere_s {
    float       a;
    float       b;
    float       c;
    float       r;
    float       ka;
    float       kd;
    float       ks;
    float       kr;
    slab        bv;                 //bounding 'slab'
    DWORD       col;
    struct sphere_s *pNext;
    struct sphere_s *pPrev;
} sphere;
#pragma pack()

#pragma pack(1)
typedef struct light_s {
    float       a;
    float       b;
    float       c;
    float       r;
    float       ip;
    struct light_s *pNext;
    struct light_s *pPrev;
} light;
#pragma pack()

#pragma pack(1)
typedef struct {
    float       A;
    float       B;
    float       C;
    float       D;
} plane;
#pragma pack()

#pragma pack(1)
typedef struct {
//    DWORD frames;
    ray   data [1000];
} path;
#pragma pack()


DWORD pindex;

vertex2D    FlareOrigin;
Svertex2D   FlareVector;
vertex2D    FlarePos;

DWORD             ambient=10;
DWORD             addintens=0;  
sphere            HeadSphere, sphere1, sphere3, sphere4, sphere5, TailSphere;
sphere            *pSphere, *pSphere2, *pSphere3;

light           sphere2;

VECTOR3D             TempRay, TempRay1, TempRay2, TempRay3, TempRay4;

plane           plane1;

VECTOR3D            *RayTable;
VECTOR3D            *NormalTable;
VECTOR3D            *PointTable;

extern BYTE        *virtual;                 //puntero a la pantalla virtual
BYTE        *virtual2;                 //puntero a la pantalla virtual, slo
                                        //no bancos.

float       *SrootTable;                //puntero a la tabla de races
                                        //cuadradas
float       depth, intens;
DWORD       color;

BYTE       FrameType=0;

path*      plightpath;
path*      psphere1path;
path*      psphere3path;
path*      psphere4path;

void        CalculateRays (void);
float       IntersectSphere (sphere, VECTOR3D );

float       IntersectSphereAsm (sphere *, VECTOR3D *, float *, float *);
#pragma aux IntersectSphereAsm modify [eax edx edi];
#pragma aux IntersectSphereAsm parm [eax] [ebx] [ecx] [esi] ;

    

float       IntersectSphere0Asm (sphere *, VECTOR3D *, VECTOR3D *, float * );
#pragma aux IntersectSphere0Asm modify [eax];
#pragma aux IntersectSphere0Asm parm [eax] [edx] [ebx] [ecx];

void fatal_error(const BYTE *, ...);

float       IntersectPlane (plane, VECTOR3D );
float       IntersectPlane0 (plane, VECTOR3D, VECTOR3D);
float       IntersectSphere0 (sphere, VECTOR3D, VECTOR3D);
float       IntersectLight0 (light, VECTOR3D, VECTOR3D);
VECTOR3D         NormalSphere (sphere, float, float, float );
VECTOR3D         NormalLight (light, float, float, float );
float       FindCos (VECTOR3D, VECTOR3D);
float       FindIllum (float, sphere, light);
void        SortScene (void);
void        Smooth (void);

void        CalculateRoots (void);
void        CalculateSlab (sphere *);

void        Draw_Main_Flare (BYTE *, BYTE *, SDWORD, SDWORD, DWORD, DWORD, DWORD, DWORD);
void        ClipBitmap_16 (BYTE *, BYTE *, SDWORD, SDWORD, DWORD, DWORD );
                   
void        LoadPath(path *, BYTE *);

void        draw_lens_flares(void);

BYTE read_tga_map(BYTE *,BYTE *,BYTE *);
BYTE read_tga_picture(BYTE *, BYTE *, DWORD, DWORD);
void convert_pal(BYTE *pal);
void convert_pal_8(BYTE *palin, BYTE *palout);
BYTE precalc_gouraud(BYTE *, BYTE *, BYTE *, float, float, float, float);

void    init_ray (DWORD, DWORD);
void    frame_ray (DWORD);
void    end_ray (void);

DWORD   intensify_32 (DWORD, DWORD);
#pragma aux intensify_32= \
"   shl     ebx, 8" \
"   add     eax, ebx"\
"   shl     ebx, 8"   \
"   add     eax, ebx"  \
"   shl     ebx, 8"     \
"   add     eax, ebx"    \
parm [eax] [ebx] \        
value [eax] \
modify [eax ebx];

void    pPixel_16(BYTE *, WORD);
#pragma aux pPixel_16= \
"    mov     [eax], bx" \
parm [eax] [ebx];

/*
DWORD   add_16(DWORD, DWORD);
#pragma aux add_16= \
"and        edx, 11111b"\
"and        ecx, 11111b"\
"add        edx, ecx"\
"cmp        edx, 11111b"\
"jb         np1"\
"mov        edx, 11111b"\
"np1:"\
"mov        ecx, eax"\
"mov        esi, ebx"\
"and        esi, 11111100000b"\
"and        ecx, 11111100000b"\
"add        esi, ecx"\
"cmp        esi, 11111100000b"\
"jb         np2"\
"mov        esi, 11111100000b"\
"np2:"\
"or         edx, esi"\
"and        eax, 1111100000000000b"\
"and        ebx, 1111100000000000b"\
"add        eax, ebx"\
"cmp        eax, 1111100000000000b"\
"jb         np3"\
"mov        eax, 1111100000000000b"\
"np3:"\
"or         edx, eax"\
parm [ecx] [edx] \
value [edx] \
modify [eax ebx ecx edx esi];
*/

DWORD   add_16(DWORD, DWORD);
#pragma aux add_16= \
"and        ecx, 1111011111011111b"\
"and        edx, 1111011111011111b"\
"add        ecx, edx"\
"test       ecx, 0000000000100000b"\
"jz         no_overflow_1"\
"or         ecx, 0000000000011111b"\
"no_overflow_1:"\
"test       ecx, 0000100000000000b"\
"jz         no_overflow_2"\
"or         ecx, 0000011111100000b"\
"no_overflow_2:"\
"test       ecx, 10000000000000000b"\
"jz         no_overflow_3"\
"or         ecx, 1111100000000000b"\
"no_overflow_3:"\
parm [ecx] [edx] \
value [ecx] \
modify [ecx edx];


DWORD (*add_16or15)(DWORD, DWORD);

/*
DWORD   add_15(DWORD, DWORD);
#pragma aux add_15= \
"mov        ecx, eax"\
"mov        edx, ebx"\
"and        edx, 11111b"\
"and        ecx, 11111b"\
"add        edx, ecx"\
"cmp        edx, 11111b"\
"jb         np1"\
"mov        edx, 11111b"\
"np1:"\
"mov        ecx, eax"\
"mov        esi, ebx"\
"and        esi, 1111100000b"\
"and        ecx, 1111100000b"\
"add        esi, ecx"\
"cmp        esi, 1111100000b"\
"jb         np2"\
"mov        esi, 1111100000b"\
"np2:"\
"or         edx, esi"\
"and        eax, 111110000000000b"\
"and        ebx, 111110000000000b"\
"add        eax, ebx"\
"cmp        eax, 111110000000000b"\
"jb         np3"\
"mov        eax, 111110000000000b"\
"np3:"\
"or         edx, eax"\
parm [eax] [ebx] \
value [edx] \
modify [eax ebx ecx edx esi];
*/

DWORD   add_15(DWORD, DWORD);
#pragma aux add_15= \
"and        ecx, 111101111011111b"\
"and        edx, 111101111011111b"\
"add        ecx, edx"\
"test       ecx, 000000000100000b"\
"jz         no_overflow_1"\
"or         ecx, 000000000011111b"\
"no_overflow_1:"\
"test       ecx, 000010000000000b"\
"jz         no_overflow_2"\
"or         ecx, 000001111100000b"\
"no_overflow_2:"\
"test       ecx, 1000000000000000b"\
"jz         no_overflow_3"\
"or         ecx, 111110000000000b"\
"no_overflow_3:"\
parm [ecx] [edx] \
value [ecx] \
modify [ecx edx];



DWORD _32to16 (DWORD);
#pragma aux _32to16= \
"    mov     ecx, eax" \  
"    mov     edx, eax" \
"    shr     eax, 11" \
"    and     eax, 11111b" \
"    shr     edx, 16-5+2"\
"    and     edx, 11111100000b" \
"    shr     ecx, 24-11+3"\
"    and     ecx, 1111100000000000b" \
"    or      eax, edx"\
"    or      eax, ecx"\
parm [eax] \
value [eax] \
modify [eax ecx edx];

DWORD (*_32to16or15)(DWORD);

DWORD _32to15 (DWORD);
#pragma aux _32to15= \
"    mov     ecx, eax" \  
"    mov     edx, eax" \
"    shr     eax, 11" \
"    and     eax, 11111b" \
"    shr     edx, 19-5"\
"    and     edx, 1111100000b" \
"    shr     ecx, 27-10"\
"    and     ecx, 111110000000000b" \
"    or      eax, edx"\
"    or      eax, ecx"\
parm [eax] \
value [eax] \
modify [eax ecx edx];


DWORD Blend_16(DWORD, DWORD);
#pragma aux Blend_16= \
"and    eax, 1111011111011111b " \
"and    ebx, 1111011111011111b " \
"add    eax, ebx" \
"shr    eax, 1"\
parm [eax] [ebx] \
value [eax] \
modify [eax ebx];

DWORD (*Blend_16or15)(DWORD, DWORD);

DWORD Blend_15(DWORD, DWORD);
#pragma aux Blend_15= \
"and    eax, 111101111011111b " \
"and    ebx, 111101111011111b " \
"add    eax, ebx" \
"shr    eax, 1"\
parm [eax] [ebx] \
value [eax] \
modify [eax ebx];


DWORD Make_16(DWORD);
#pragma aux Make_16= \
"mov    ebx, eax"\
"mov    ecx, eax"\
"shr    eax, 3"\
"shl    ebx, 5-2"\
"and    ebx, 11111100000b"\
"shl    ecx, 11-3"\
"and    ecx, 1111100000000000b"\
"or     eax, ebx"\
"or     eax, ecx"\
parm [eax] \
value [eax] \
modify [eax ebx ecx];


DWORD Blend_32(DWORD, DWORD);
#pragma aux Blend_32= \
"and    eax, 11111110111111101111111000000000b " \
"and    ebx, 11111110111111101111111000000000b " \
"add    eax, ebx" \
"shr    eax, 1"\
parm [eax] [ebx] \
value [eax] \
modify [eax ebx];

DWORD _16to32(WORD);
#pragma aux _16to32= \
"mov    ebx, eax " \
"mov    ecx, eax " \
"and    ebx, 11111b" \
"and    ecx, 11111100000b" \
"and    eax, 1111100000000000b"\
"shl    ebx, 11" \
"shl    ecx, 16-5+2" \
"shl    eax, 24-11+3" \
"or     eax, ecx" \
"or     eax, ebx" \
parm [eax] \
value [eax] \
modify [eax ebx ecx];

vertex2D    VertArray [4];
BYTE        BottomVert;
BYTE        ActVertL, ActVertR, NextVertL, NextVertR;
float       SlopeL, SlopeR;
float       ptrL, ptrR;
float       heightL, heightR;


BYTE        *sPtr;
DWORD       Xcount;

DWORD   __add_15(DWORD, DWORD);
DWORD   __add_16(DWORD, DWORD);
DWORD   __32to16 (DWORD); 
DWORD   __32to15 (DWORD); 
DWORD   __Blend_16(DWORD, DWORD);
DWORD   __Blend_15(DWORD, DWORD);
   
DWORD   mode_avail_x;
DWORD   mode_avail_y;
DWORD   mode_avail_depth;

extern BOOLEAN icg_boss;

//FPS
static BYTE fps_info[15];                  // Texto final
static DWORD last_frame,temp_frame;        // Variables auxiliares
static float last_time,temp_time,fps;
